---
title: Promise() constructor
slug: Web/JavaScript/Reference/Global_Objects/Promise/Promise
tags:
  - Constructor
  - JavaScript
  - Promise
  - Reference
---
<div>{{JSRef}}</div>

<p>The <strong><code>Promise</code></strong> constructor is primarily used to wrap functions that do not already support promises.</p>

<div>{{EmbedInteractiveExample("pages/js/promise-constructor.html", "taller")}}</div>

<div class="hidden">The source for this interactive demo is stored in a GitHub repository. If you'd like to contribute to the interactive demo project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">new Promise(<var>executor</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>executor</var></code></dt>
 <dd>A {{jsxref("function")}} to be executed by the constructor, during the process of constructing the new <code>Promise</code> object. The <code><var>executor</var></code> is custom code that ties an outcome to a promise. You, the programmer, write the <code><var>executor</var></code>. The signature of this function is expected to be:</dd>
 <dt>
 <pre class="brush: js notranslate">function(<var>resolutionFunc</var>, <var>rejectionFunc</var>){
    // typically, some asynchronous operation.
}
</pre>
 </dt>
 <dd>At the time when the constructor generates the new <code>Promise</code> object, it also generates a corresponding pair of functions for <code><var>resolutionFunc</var></code> and <code><var>rejectionFunc</var></code>; these are "tethered" to the <code>Promise</code> object. Therefore, the code within the <code><var>executor</var></code> has the opportunity to perform some operation and then reflect the operation's outcome (If the value is not another Promise object) as either "fulfilled" or "rejected" by terminating with an invocation of either the <code><var>resolutionFunc</var></code> or the <code><var>rejectionFunc</var></code>, respectively.</dd>
 <dd>The <code><var>executor</var></code> has no meaningful return value. It communicates via the side-effect caused by <code><var>resolutionFunc</var></code> or <code><var>rejectionFunc</var></code>. The side-effect is that the <code>Promise</code> object becomes "resolved."</dd>
 <dd>Typically, it works like this: The operation within <code><var>executor</var></code> is asynchronous and provides a callback. The callback is defined within the <code><var>executor</var></code> code. The callback terminates by invoking <code><var>resolutionFunc</var></code>. The invocation of <code><var>resolutionFunc</var></code> includes a <code>value</code> parameter. The <code>value</code> is passed back to the tethered <code>Promise</code> object. The <code>Promise</code> object (asynchronously) invokes any <code>.then()</code> associated with it. The <code>value</code> received by <code>.then()</code> is passed to the invocation of <code>handleFulfilled</code> as an input parameter (See "Chained Promises" section).</dd>
 <dd>The <code><var>executor</var></code> might also include a <code>try{} catch()</code> block that invokes <code><var>rejectionFunc</var></code> upon error.</dd>
 <dd>The signatures of these two functions are simple, they accept a single parameter of any type. Of course, the actual names of these functions can be whatever is desired, i.e. they are named as the parameters of <code><var>executor</var></code>. Each function is used by calling it when appropriate.</dd>
</dl>

<dl>
 <dd>
 <pre class="brush: js notranslate">resolutionFunc(value) // call on fulfilled
rejectionFunc(reason) // call on <em>rejected</em></pre>

 <p>The returned <code>value</code> can be another promise object, in which case the promise gets dynamically inserted into the chain.</p>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>When called via <code>new</code>, the <code>Promise</code> constructor returns a promise object. The promise object will become "resolved" when either of the functions <code><var>resolutionFunc</var></code> or <code><var>rejectionFunc</var></code> are invoked. Note that if you call <code><var>resolutionFunc</var></code> or <code><var>rejectionFunc</var></code> and pass another Promise object as an argument, you can say that it is "resolved", but still cannot be said to be "settled".</p>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_a_new_Promise">Creating a new Promise</h3>

<p>A <code>Promise</code> object is created using the <code>new</code> keyword and its constructor. This constructor takes a function, called the "executor function", as its parameter. This function should take two functions as parameters. The first of these functions (<code>resolve</code>) is called when the asynchronous task completes successfully and returns the results of the task as a value. The second (<code>reject</code>) is called when the task fails, and returns the reason for failure, which is typically an error object.</p>

<pre class="brush: js; notranslate">const myFirstPromise = new Promise((resolve, reject) =&gt; {
  // do something asynchronous which eventually calls either:
  //
  //   resolve(someValue)        // fulfilled
  // or
  //   reject("failure reason")  // rejected
});
</pre>

<h3 id="Making_functions_return_a_Promise">Making functions return a Promise</h3>

<p>To provide a function with promise functionality, have it return a promise:</p>

<pre class="brush: js; notranslate">function myAsyncFunction(url) {
  return new Promise((resolve, reject) =&gt; {
    const xhr = new XMLHttpRequest()
    xhr.open("GET", url)
    xhr.onload = () =&gt; resolve(xhr.responseText)
    xhr.onerror = () =&gt; reject(xhr.statusText)
    xhr.send()
  });
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-promise-constructor', 'Promise constructor')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">To contribute to this compatibility data, please write a pull request against this repository: <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a>.</div>

<p>{{Compat("javascript.builtins.Promise.Promise")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Using_promises">Using Promises</a></li>
</ul>
